from src.batch.ultmarc.utmp_tables.table_mapper.ultmarc_table_mapper import \
    UltmarcTableMapper
from src.batch.ultmarc.utmp_tables.tables.com_med_area_city import ComMedAreaCity


class ComMedAreaCityMapper(UltmarcTableMapper):
    """レイアウト区分124: COM_医療圏都道府県市町村対応表 登録処理"""

    # レコード存在確認SQL
    RECORD_EXISTS_QUERY = """\
    SELECT
        COUNT(*) AS count_num
    FROM
        src05.com_med_area_city
    WHERE
        prefc_cd = :prefc_cd
        AND
        med_sphe_cd = :med_sphe_cd
        AND
        jis_prefc_cd = :jis_prefc_cd
        AND
        jis_city_cd = :jis_city_cd
    """
    # データ登録用SQL
    INSERT_QUERY = """\
    INSERT INTO src05.com_med_area_city
    (
        prefc_cd,
        med_sphe_cd,
        jis_prefc_cd,
        jis_city_cd,
        zen_prefcode,
        zen_medareacode,
        regist_ymd,
        sys_regist_date,
        regist_prgm_id,
        sys_update_date,
        update_prgm_id
    )
    VALUES (
        :prefc_cd,
        :med_sphe_cd,
        :jis_prefc_cd,
        :jis_city_cd,
        :zen_prefcode,
        :zen_medareacode,
        :execute_date_str_ymd,
        :execute_datetime,
        :program_name,
        :execute_datetime,
        :program_name
    )
    """

    # データ更新用SQL
    UPDATE_QUERY = """\
    UPDATE
        src05.com_med_area_city
    SET
        zen_prefcode = :zen_prefcode,
        zen_medareacode = :zen_medareacode,
        update_ymd = :execute_date_str_ymd,
        sys_update_date = :execute_datetime,
        update_prgm_id = :program_name
    WHERE
        prefc_cd = :prefc_cd
        AND
        med_sphe_cd = :med_sphe_cd
        AND
        jis_prefc_cd = :jis_prefc_cd
        AND
        jis_city_cd = :jis_city_cd
    """

    # 『修正区分がB(修正)かつ追加削除区分が1(退職)』の場合、物理削除
    PHYSICAL_DELETE_QUERY = """\
    DELETE FROM
        src05.com_med_area_city
    WHERE
        prefc_cd = :prefc_cd
        AND
        med_sphe_cd = :med_sphe_cd
        AND
        jis_prefc_cd = :jis_prefc_cd
        AND
        jis_city_cd = :jis_city_cd
    """

    record: ComMedAreaCity

    def __init__(self, record: list[str], db) -> None:
        super().__init__(record, db, ComMedAreaCity)
        program_name = __name__.split('.')[-1]  # 当モジュール名(現行から変わっている)
        # モジュール名をクエリパラメータに設定
        self.query_parameter['program_name'] = program_name
        # 読み込んだレコード値もクエリパラメータに追加
        self.query_parameter = {**self.query_parameter, **self.record.to_sql_parameter()}

    def make_query(self):
        # 『修正区分がB(修正)かつ追加削除区分が1(退職)』の場合、物理削除
        if self.record.maintflag == 'B' and self.record.addDelDiv == '1':
            self.queries.append(self.PHYSICAL_DELETE_QUERY)
            return

        # 追加、更新の場合
        self.queries.append(self.__make_upsert_query())
        return

    def __make_upsert_query(self):
        # レコードの存在確認
        record_count = self.db.execute_select(self.RECORD_EXISTS_QUERY, self.query_parameter)
        # 存在しない場合はInsert
        if record_count[0]['count_num'] == 0:
            return self.INSERT_QUERY

        # 存在する場合はUpdate
        return self.UPDATE_QUERY
